<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Bootstrap Example</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>
  <body>
    <div class="container">
      <h2 style="text-align: center">Danh sách người dùng</h2>

      <table
        class="table table-bordered table-striped table-hover"
        id="table-users"
      >
        <thead>
          <tr>
            <th>Mã người dùng</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Age</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>

    <!-- Modal user infor-->
    <div id="user-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">User Detail Information</h5>
            <button type="button" class="close" data-dismiss="modal">
              &times;
            </button>
          </div>
          <!-- Modal body - chứa form dữ liệu -->
          <div class="modal-body">
            <form>
              <!-- form thiết kế như form bình thường, theo grid model -->
              <div class="row form-group">
                <label class="col-sm-4 col-form-label">User Id</label>
                <div class="col-sm-8">
                  <input class="form-control" id="input-modal-userid" />
                </div>
              </div>

              <div class="row form-group">
                <label class="col-sm-4 col-form-label">First name</label>
                <div class="col-sm-8">
                  <input class="form-control" id="input-modal-firstname" />
                </div>
              </div>

              <div class="row form-group">
                <label class="col-sm-4 col-form-label">Last name</label>
                <div class="col-sm-8">
                  <input class="form-control" id="input-modal-lastname" />
                </div>
              </div>

              <div class="row form-group">
                <label class="col-sm-4 col-form-label">Age</label>
                <div class="col-sm-8">
                  <input class="form-control" id="input-modal-age" />
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button
              type="button"
              id="btn-modal-close"
              class="btn btn-secondary"
              data-dismiss="modal"
            >
              Close
            </button>
          </div>
        </div>
      </div>
    </div>

    ​
    <script>
      $(document).ready(function () {
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gJsonUser = `{
          "description": "Data user",
          "users": [
            {
              "userId": 1,
              "firstname": "Test1",
              "lastname": "User1",
              "age": 18
            },
            {
              "userId": 2,
              "firstname": "Test2",
              "lastname": "User2",
              "age": 19
            },
            {
              "userId": 3,
              "firstname": "Test3",
              "lastname": "User3",
              "age": 18
            },
            {
              "userId": 4,
              "firstname": "Test4",
              "lastname": "User4",
              "age": 20
            },
            {
              "userId": 5,
              "firstname": "Test5",
              "lastname": "User5",
              "age": 21
            },
            {
              "userId": 6,
              "firstname": "Test6",
              "lastname": "User6",
              "age": 20
            }
          ]
        }`;

        // Biến mảng toàn cục chứa danh sách tên các thuộc tính
        const gUSER_COLS = ["userId", "firstname", "lastname", "age", "action"];

        // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
        const gUSER_ID_COL = 0;
        const gUSER_FIRSTNAME_COL = 1;
        const gUSER_LASTNAME_COL = 2;
        const gUSER_AGE_COL = 3;
        const gUSER_ACTION_COL = 4;
        // parsing json to object
        var gUserObj = JSON.parse(gJsonUser);
        // Chuyển đổi html table thành DataTable và cấu hình cho DataTable
        var gUserTable = $("#table-users").DataTable({
          data: gUserObj.users,
          columns: [
            { data: gUSER_COLS[gUSER_ID_COL] },
            { data: gUSER_COLS[gUSER_FIRSTNAME_COL] },
            { data: gUSER_COLS[gUSER_LASTNAME_COL] },
            { data: gUSER_COLS[gUSER_AGE_COL] },
            { data: gUSER_COLS[gUSER_ACTION_COL] },
          ],
          columnDefs: [
            {
              targets: gUSER_ACTION_COL,
              defaultContent:
                "<button class='btn btn-primary user-detail'>Chi tiết</button>",
            },
          ],
        });

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        // gắn sự kiện click cho các nút user detail
        $("#table-users").on("click", ".user-detail", function () {
          onUserDetailClick(this);
        });

        // gán sự kiện click cho nút ok ở modal
        $("#btn-modal-close").click(function () {
          $("#user-modal").modal("hide");
        });

        // khi có sự kiện modal ẩn đi thì sẽ làm gì đó?
        $("#user-modal").on("hidden.bs.modal", function () {
          console.log("Modal hide");
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm xử lý khi click vào nút user detail
        function onUserDetailClick(paramUserDetailBtn) {
          // lấy được data của user
          var vTableRow = $(paramUserDetailBtn).parents("tr");
          var vDataTableRow = gUserTable.row(vTableRow);
          var vUserData = vDataTableRow.data();
          /***
           * TODO: xử lý tiếp để show dữ liệu user lên Modal
           */
          //hiển thị modal lên
          $("#user-modal").modal("show");

          // khi có sự kiện modal show lên thì sẽ làm gì đó?
          $("#user-modal").on("shown.bs.modal", function () {
            //gán dữ liệu lên modal
            $("#input-modal-userid").val(vUserData.userId);
            $("#input-modal-firstname").val(vUserData.firstname);
            $("#input-modal-lastname").val(vUserData.lastname);
            $("#input-modal-age").val(vUserData.age);
          });
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      });
    </script>
  </body>
</html>
​
